#ifndef PHENOTYPE_H_
#define PHENOTYPE_H_ 1

#include <dtable.h>
#include <ga/genotype.h>

struct phenotype;

struct phenotype_ops
{
	void (*fprint)(const struct phenotype *, FILE *out);
};

struct phenotype
{
	const struct phenotype_ops *ops;
	int (*cleanup)(struct phenotype *);
	double fitness;
	double scaled_fitness;
};

static inline int
phenotype_cleanup(struct phenotype *pt)
{
	return pt->cleanup(pt);
}

static inline void
phenotype_fprint(const struct phenotype *pt, FILE *out)
{
	return pt->ops->fprint(pt, out);
}

#endif
