#ifndef PRAND_H_
#define PRAND_H_ 1

#include <stdlib.h>

#define PRAND_MAX RAND_MAX

struct prand;

struct prand_ops
{
	int (*prand)(struct prand *);
};

struct prand
{
	const struct prand_ops *ops;
	int (*cleanup)(struct prand *);
};

static inline int
prandi_range(struct prand *pr, int from, int to)
{
	return (pr->ops->prand(pr) + from) % to;
}

static inline int
prandi(struct prand *pr)
{
	return pr->ops->prand(pr);
}

static inline float
prandf(struct prand *pr)
{
	return (float)pr->ops->prand(pr) / (float)PRAND_MAX;
}

static inline double
prandd(struct prand *pr)
{
	return (double)pr->ops->prand(pr) / (double)PRAND_MAX;
}

static inline int
prand_cleanup(struct prand *pr)
{
	return pr->cleanup(pr);
}

#endif
