#ifndef UPRAND_H_
#define UPRAND_H_ 1

#include <prand.h>

/* FIXME: do we need to support calling same instance from multiple threads?
 *
 * If needed, we can introduce array of per CPU buffers of random numbers, and
 * just fill as needed. This would only require taking a lock when filling the
 * buffers.
 *
 * Circular buffers?
 * Probably need both hw and sw memory barriers, kongull is amd64(?) which
 * means pretty strict memory ordering, so should probably not cause a problem.
 */

struct uprand
{
	struct prand base;
	unsigned int seed;
	char padding1[4];
};

struct prand *uprand_create(void);
int uprand_init(struct uprand *upr);

#endif /* UPRANG_H_ */
