#include <dbg.h>
#include <ga/individual.h>

#include <stdlib.h>
#include <errno.h>
#include <string.h>

int
individual_init(struct individual *ind, struct genotype *gt)
{
	ind->genotype = gt;
	ind->phenotype = NULL;
	return 0;
}

int
individual_init_clone(struct individual *ind, const struct genotype *gt)
{
	struct genotype *gtclone;

	gtclone = genotype_clone(gt);
	if (!gtclone)
	{
		int ret = -errno;
		dbg_error("%s\n", strerror(-ret));
		return ret;
	}

	ind->genotype = gtclone;
	ind->phenotype = NULL;
	return 0;
}

int
individual_cleanup(struct individual *ind)
{
	genotype_cleanup(ind->genotype);
	if (ind->phenotype)
		phenotype_cleanup(ind->phenotype);
	return 0;
}
