#include <dbg.h>

#include <stdio.h>
#include <stdarg.h>

int dbg_trace_level = DBG_TRACE_LEVEL_DEFAULT;

static const char *level_str_lookup_table[] =
{
	"fatal",
	"error",
	"warning",
	"notice",
	"info",
	"debug"
};

static const char *
level_str(int level)
{
	return level_str_lookup_table[level];
}

void
dbg_printf(int level, const char *file, int line, const char *fmt, ...)
{
	va_list ap;
	fprintf(stderr, "%s: %s: %d: ", level_str(level), file, line);

	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
	fflush(stderr);
}
